'use strict';
var callExpressionB = require('nodes');
var nodes = callExpressionB.nodes, syntax = callExpressionB.syntax;
var callExpressionA = require('../util/self');
var getSelfId = callExpressionA.getSelfId;
var callExpression = require('../util/arguments');
var getArgumentsId = callExpression.getArgumentsId;
exports.default = function arrowify(program) {
  var q = [
      '#ArrowFunctionExpression => #ThisExpression',
      '#ArrowFunctionExpression => #Identifier:reference[name=arguments]'
    ];
  program.search(q).forEach(function (expression) {
    var arrowFunction = expression.scope();
    var arrowScope = arrowFunction.scope('[type!=ArrowFunctionExpression]');
    var id;
    if (expression.type === syntax.ThisExpression) {
      id = getSelfId(arrowScope);
    } else {
      id = getArgumentsId(arrowScope);
    }
    expression.parentNode.replaceChild(expression, id.clone());
  });
  program.search('#ArrowFunctionExpression').forEach(function (node) {
    var shallow = new nodes.FunctionExpression(node);
    node.parentNode.replaceChild(node, shallow);
  });
};