'use strict';
var callExpressionB = require('./id');
var getUniqueName = callExpressionB.getUniqueName;
var callExpressionA = require('./string');
var express = callExpressionA.express;
var callExpression = require('./insertion');
var insertAfterStrict = callExpression.insertAfterStrict;
var extend = 'function (SuperClass, Class, prototype, members) {\n  var descriptors = function(object) {\n    var base = {}, descriptor;\n    for (var key in object) {\n      descriptor = Object.getOwnPropertyDescriptor(object, key);\n      if (!(\'get\' in descriptor) && !(\'set\' in descriptor)) {\n        descriptor.enumerable = false;\n      }\n      base[key] = descriptor;\n    }\n    return base;\n  };\n\n  if (SuperClass) Class.__proto__ = SuperClass;\n  Object.defineProperty(Class, \'prototype\', {\n    value: Object.create(SuperClass === null ? null : SuperClass.prototype, descriptors(prototype))\n  });\n\n  Object.defineProperty(Class.prototype, \'constructor\', { value: Class });\n\n  if (members) Object.defineProperties(Class, descriptors(members));\n  return Class;\n}';
var getExtendId = function (node) {
  if (!node.extendId) {
    var extendName = getUniqueName(node, 'extend');
    var declaration = express('var ' + extendName + ' = ' + extend);
    insertAfterStrict(node, declaration);
    node.extendId = declaration.declarations[0].id;
  }
  return node.extendId;
};
exports.getExtendId = getExtendId;