'use strict';
var callExpressionB = require('./id');
var getUniqueName = callExpressionB.getUniqueName;
var callExpressionA = require('./string');
var express = callExpressionA.express;
var callExpression = require('./insertion');
var insertAfterStrict = callExpression.insertAfterStrict;
var spread = 'function() {\n  var array = [], last = arguments.length - 1;\n  for (var i = 0; i < last; i++) array.push(arguments[i]);\n  var iterator = arguments[last][\'@@iterator\'](), step;\n  while (!(step = iterator.next()).done) array.push(step.value);\n  return array;\n}';
var getSpreadId = function (node) {
  if (!node.spreadId) {
    var spreadName = getUniqueName(node, 'spread');
    var declaration = express('var ' + spreadName + ' = ' + spread);
    insertAfterStrict(node, declaration);
    node.spreadId = declaration.declarations[0].id;
  }
  return node.spreadId;
};
exports.getSpreadId = getSpreadId;